
/* comp3: rpc.t -> data.hpp */

#ifndef __RPC_DATA_HPP__
#define __RPC_DATA_HPP__

class Group;
class Section;
class Item;

class Group
{
   // attribute Title
   private:
      string Title;
   public:
      string getTitle () { return Title; }
      void setTitle (string p_value);

   // attribute Number
   private:
      int Number;
   public:
      int getNumber () { return Number; }
      void setNumber (int p_value);

   // list Sections
   private:
      Section * firstSection;
      Section * lastSection;
   protected:
      void linkSection (Section * item, Section * bef, Section * aft);
   public:
      Section * getFirstSection () { return firstSection; }
      Section * getLastSection () { return lastSection; }
      void insertFirstSection (Section * item);
      void insertLastSection (Section * item);
      void removeAllSections ();

   public:
      virtual ~ Group ();
      Group ();

   public:
      friend class Section;
};

class Section
{
   // attribute Identifier
   private:
      string Identifier;
   public:
      string getIdentifier () { return Identifier; }
      void setIdentifier (string p_value);

   // attribute Number
   private:
      int Number;
   public:
      int getNumber () { return Number; }
      void setNumber (int p_value);

   // list Sections
   private:
      Section * prevSection;
      Section * nextSection;
      Group * up;
   public:
      Section * getPrevSection () { return prevSection; }
      Section * getNextSection () { return nextSection; }
      Group * getUp () { return up; }
      void insertPrevSection (Section * item);
      void insertNextSection (Section * item);
      void removeSection ();

   // list Items
   private:
      Item * firstItem;
      Item * lastItem;
   protected:
      void linkItem (Item * item, Item * bef, Item * aft);
   public:
      Item * getFirstItem () { return firstItem; }
      Item * getLastItem () { return lastItem; }
      void insertFirstItem (Item * item);
      void insertLastItem (Item * item);
      void removeAllItems ();

   public:
      virtual ~ Section ();
      Section ();

   public:
      friend class Group;
      friend class Item;
};

class Item
{
   // attribute Text
   private:
      string Text;
   public:
      string getText () { return Text; }
      void setText (string p_value);

   // attribute Comment
   private:
      string Comment;
   public:
      string getComment () { return Comment; }
      void setComment (string p_value);

   // list Items
   private:
      Item * prevItem;
      Item * nextItem;
      Section * up;
   public:
      Item * getPrevItem () { return prevItem; }
      Item * getNextItem () { return nextItem; }
      Section * getUp () { return up; }
      void insertPrevItem (Item * item);
      void insertNextItem (Item * item);
      void removeItem ();

   public:
      virtual ~ Item ();
      Item ();

   public:
      friend class Section;
};

void test_Group_new (Group * obj);
void test_Group_delete (Group * obj);
void test_Group_setTitle (Group * obj, string p_value);
void test_Group_setNumber (Group * obj, int p_value);
void test_Group_insertFirstSection (Group * obj, Section * item);
void test_Group_insertLastSection (Group * obj, Section * item);
void test_Section_new (Section * obj);
void test_Section_delete (Section * obj);
void test_Section_setIdentifier (Section * obj, string p_value);
void test_Section_setNumber (Section * obj, int p_value);
void test_Section_insertFirstItem (Section * obj, Item * item);
void test_Section_insertLastItem (Section * obj, Item * item);
void test_Section_insertPrevSection (Section * obj, Section * item);
void test_Section_insertNextSection (Section * obj, Section * item);
void test_Section_removeSection (Section * obj);
void test_Item_new (Item * obj);
void test_Item_delete (Item * obj);
void test_Item_setText (Item * obj, string p_value);
void test_Item_setComment (Item * obj, string p_value);
void test_Item_insertPrevItem (Item * obj, Item * item);
void test_Item_insertNextItem (Item * obj, Item * item);
void test_Item_removeItem (Item * obj);

#endif /* __RPC_DATA_HPP__ */
