
/* rpc.t */

project rpc;

module data
{
    /* data structures */

    class Group
    {
        attr <string> Title;
        attr <int> Number;

        list <Section> Sections
        {
           Suffix1 = Section;
           Suffix2 = Sections;
        }
    };

    class Section
    {
        attr <string> Identifier;
        attr <int> Number { Init = 0; }

        list <Item> Items
        {
           Suffix1 = Item;
           Suffix2 = Items;
        }
    };

    class Item
    {
        attr <string> Text;
        attr <string> Comment;
    };

    /* RPC */

    TRpcOptions
    {
        Name = test; // interface file name

        program_number = 0x20304050; // !? hex numbers
        version_number = 4;

        trace = true;

        TRpcClassOptions
        {
            ref = Group;
        }

        TRpcClassOptions
        {
            ref = Section;
        }

        TRpcClassOptions
        {
            ref = Item;
        }
    }
}

module client
{
   TRpcClientCode
   {
      start_func = start_client; // function identifier
      stop_func = stop_client; 
      from = "test"; // top level TRpcOptions
   }
}

module server
{
   TRpcServerCode
   {
      start_func = start_server; 
      from = "test";
   }

   TRpcEmptyCode
   {
      from = "test";
   }
}

/* make */

make 
{
    // automake = true;
    // autoinit = true;
    autoclean = true;
    debug = true;
    kdevelop = true;


    keep_kdevprj = true;
    // clean "Makefile.test"; // !?

    program client
    {
       tt_source data;
       tt_source client;
       use_utils;
       rpc { idl = "test"; client = true; }
    };

    program server
    {
       tt_source data;
       tt_source server;
       use_utils; 
       rpc { idl = "test"; server = true; }
    };
}
